Subject: Server Push and Conditional Requests

From: Mark Nottingham <[email-masked]>
Date: Wed, 24 Aug 2016 14:26:27 +1000

Thinking about how Server Push interacts with conditional requests <http://httpwg.org/specs/rfc7232.html>, I can see three interesting modes of operation, outlined below.

1. If-Match / If-Unmodified-Since

If the server has immediate access to the response being pushed (e.g., if the server is authoritative for it, or it is fresh in cache), it might want to send conditional headers in the `PUSH_PROMISE` request, to give the client the earliest possible chance to send a `RST_STREAM` (since the promised stream might be delayed due to priorities, etc.).

The most obvious way to do this with existing headers is using `If-Match` and/or `If-Unmodified-Since`; if the validator matches what the client has, it can send a `RST_STREAM`; otherwise, they can wait for the full response (which will presumably have validators matching those sent in the request).

~~~
:method: GET
:scheme: https
:authority: www.example.com
:path: /images/1234.jpg
Host: www.example.com
If-Match: "abcdef"
~~~

Here, when a client receives these headers in a `PUSH_PROMISE`, it can send a `RST_STREAM` if it has a fresh cached response for `https://www.example.com/images/1234.jpg` with the `ETag` "abcdef". If it does not do so, the server will continue to push the successful (`2xx`) response (since the `ETag` does in fact match what is pushed).

2.  If-None-Match / If-Modified-Since

If the server does not have a fresh local copy of the response, but does have access to a stale one (in the meaning of RFC7234), it can `PUSH_PROMISE` with `If-None-Match` and/or `If-Modified-Since`:

~~~
:method: GET
:scheme: https
:authority: www.example.com
:path: /images/5678.jpg
Host: www.example.com
If-None-Match: "lmnop"
~~~

That way, the client again has an opportunity to send `RST_STREAM` if it already has a fresh copy with that validator in cache. 

Once the server has obtained a fresh (possibly validated) response, it can either push a `304 (Not Modified)` response in the case that the `ETag` hasn't changed, or a successful (`2xx`) response if it has.

Note that if the client has a fresh copy in cache, but the server does not, the client can still use the fresh copy; it has not been invalidated just because the server has not kept its copy fresh.

3. 304 (Not Modified) without a Conditional

If the server believes that the client does have a stale but valid copy in its cache (e.g., through the use of a cache digest), it can send a `PUSH_PROMISE` followed by a pushed `304 (Not Modified)` response to revalidate that cached response, thereby making it fresh in the client's cache.

If the server has a local copy of the response that it wishes to use, it can send the PUSH_PROMISE with an `If-None-Match` and/or `If-Modified-Since` conditional, as above. 

However, if it does not, it will still be desirable to generate the `PUSH_PROMISE` as soon as possible, so as to avoid the race described in RFC7540, Section 8.2.1.

To allow this, a request without a conditional can be sent:

~~~
:method: GET
:scheme: https
:authority: www.example.com
:path: /images/9012.jpg
Host: www.example.com
~~~

When the response body is available to the server, it can send a `304 (Not Modified)` if it believes that the client already holds a copy (fresh or stale); however, it MUST include the validators to allow the client to confirm this. For example:

~~~
:status: 304
ETag: "abc123"
Date: Tue, 3 Sep 2016 04:34:12 GMT
Content-Type: image/jpeg
Cache-Control: max-age=3600
~~~

In this case, if the client's cached response does not have the same `ETag` it SHOULD make a request to obtain a fresh response.

On the other hand, if the server determines that the client does not have the appropriate cached response, it can send the full, successful (`2xx`) response:

~~~
:status: 200
ETag: "abc123"
Date: Tue, 3 Sep 2016 04:34:12 GMT
Content-Type: image/jpeg
Cache-Control: max-age=3600

[ body ]
~~~

Note that this approach relies upon an _implicit conditional_ in the PUSH_PROMISE request. If felt necessary, this can be made explicit, for example by defining a new conditional header `If-In-Digest`.

Which of these do people think are interesting to specify, implement and use? Are there problems, or other approaches we should be considering?

Cheers,

--
Mark Nottingham   https://www.mnot.net/

---

From: Kazuho Oku <[email-masked]>
Date: Fri, 26 Aug 2016 18:40:56 +0900

Hi,

Thank you for starting the discussion.

Due to the following reasons, my preference goes to the third approach
that uses unconditional GET.

For all of the three approaches, the client would need to verify the
status code of the response, as well as the etag response header. For
the first two approaches, the request header needs to be examined as
well.

Considering the fact, I think from client’s perspective it would be
easiest to go with the third approach (i.e. unconditional GET + 304).

>From server-side perspective, I agree that by using If-Match it is
possible to send etag before sending the response headers. But I
wonder if that has practical effect.

If the server has the knowledge of the current etag value, it can push
the etag value as part of the response HEADERS frame right after
PUSH_PROMISE. The two frames would typically go into a single TCP
packet (note that a HEADERS frame containing a pushed response would
be tiny thanks to HPACK).

So my feeling is that using unconditional GET + 304 would be the
easiest to implement both on the client- and server-side, at the same
time offering practically the best performance among the three
approaches.

-- 
Kazuho Oku

---

From: Stefan Eissing <[email-masked]>
Date: Fri, 26 Aug 2016 13:34:01 +0200

Isn't the unconditional PROMISED GET -> 304 better made a PROMISED HEAD -> 200?
 
> Am 26.08.2016 um 11:40 schrieb Kazuho Oku <[email-masked]>:
> 
> Hi,
>

---

From: Kazuho Oku <[email-masked]>
Date: Fri, 26 Aug 2016 21:10:03 +0900

> Isn't the unconditional PROMISED GET -> 304 better made a PROMISED HEAD -> 200?

The issue with using HEAD for pushing etag only is that it might
introduce a trade-off on the server between delaying the main response
vs. not using push.

This is because, as pointed out by Mark, a server needs to send
PUSH_PROMISE before sending HEADERS of the parent response. If we
decide to choose a different method depending on if we want to push
the content or only the etag, it would mean that we cannot send
PUSH_PROMISE until the etag value of the pushed stream is being
determined.

In some deployments, an H2 endpoint that initiates push and the cache
that stores the contents of the resource to be pushed may exist on
different physical servers. In fact, such deployments might be common
considering most CDN POPs are constructed that way.

So my preference goes to choosing an approach that allows an H2 server
to initiate push without the knowledge of the etag (and laterwards
decide to _not_ send the content).

-- 
Kazuho Oku

---

From: Stefan Eissing <[email-masked]>
Date: Fri, 26 Aug 2016 14:31:18 +0200

Ok, now I understand the motivation better. Thanks.

Not sure if I like the disconnect between Request/Response, sorry Promise/Response, e.g. answering conditionals that are not visible on the protocol level. Maybe the PROMISE should indicate sth like a 'If-Not-In-Cache-Digest: <digest-value>' to announce that some validation will be happening.

> Am 26.08.2016 um 14:10 schrieb Kazuho Oku <[email-masked]>:
>

---

From: Kazuho Oku <[email-masked]>
Date: Sat, 27 Aug 2016 03:00:52 +0900

> Not sure if I like the disconnect between Request/Response, sorry Promise/Response, e.g. answering conditionals that are not visible on the protocol level. Maybe the PROMISE should indicate sth lik…

My understanding is that for all of the four proposed approaches (3 by
Mark + HEAD/200 by Stefan), the feature needs to be opted-in by the
browser, possibly by using a new flag in the SETTINGS frame. This is
because IIRC most (if not all) browsers that support push currently
don't recognize If-Match or If-None-Match header in a pushed request
nor does recognize a pushed 304.

Considering that, it _might not_ be necessary to have a header like
If-Not-In-Cache-Digest in a PUSH_PROMISE.

Personally, I also think that a server should be allowed to push a
cache validator (without pushing the content) regardless of if any
validation was performed on the server side.

I mean, a server that unconditionally pushes 304 would still be
useful, since it would reduce the RTT spent for stale cache
invalidation when the client has a stale-but-valid response in its
cache.

So even if we are to introduce an HTTP header to be used for pushing
304, I think the name should not imply any kind of server-side
validation.

-- 
Kazuho Oku